"""Definition of meta model 'miniModel'."""
from functools import partial
import pyecore.ecore as Ecore
from pyecore.ecore import *


name = 'miniModel'
nsURI = 'http://www.example.org/miniModel'
nsPrefix = 'miniModel'

eClass = EPackage(name=name, nsURI=nsURI, nsPrefix=nsPrefix)

eClassifiers = {}
getEClassifier = partial(Ecore.getEClassifier, searchspace=eClassifiers)


class Version(EObject, metaclass=MetaEClass):

    name = EAttribute(eType=EString, unique=True, derived=False, changeable=True)

    def __init__(self, *, name=None):
        # if kwargs:
        #    raise AttributeError('unexpected arguments: {}'.format(kwargs))

        super().__init__()

        if name is not None:
            self.name = name
            
            
class Project(EObject, metaclass=MetaEClass):

    name = EAttribute(eType=EString, unique=True, derived=False, changeable=True)
    versions = EReference(eType=Version, ordered=True, unique=True, containment=True, derived=False, upper=-1)

    def __init__(self, *, versions=None, name=None):
        # if kwargs:
        #    raise AttributeError('unexpected arguments: {}'.format(kwargs))

        super().__init__()

        if name is not None:
            self.name = name

        if versions:
            self.versions.extend(versions)


class RefProject(EObject, metaclass=MetaEClass):

    name = EAttribute(eType=EString, unique=True, derived=False, changeable=True)
    version = EReference(eType=Version, ordered=True, unique=True, containment=False, derived=False)

    def __init__(self, *, name=None, version=None):
        # if kwargs:
        #    raise AttributeError('unexpected arguments: {}'.format(kwargs))

        super().__init__()

        if name is not None:
            self.name = name

        if version is not None:
            self.version = version
