# Created by Pablo Campillo at 17/12/21
from pyecore.resources import ResourceSet, URI
from pyecore.resources.json import JsonResource

from .miniModel import Project, Version, RefProject


class TestTwoModelFiles:
    def test_create_model(self):
        v0 = Version(name="V0")
        v1 = Version(name="V1")
        
        p = Project(name='MyProject', versions=[v0, v1])

        rset = ResourceSet()
        rset.resource_factory['json'] = JsonResource

        rset = ResourceSet()
        rset.resource_factory['json'] = JsonResource
        resource = rset.get_resource(URI('miniModel.ecore'))
        mm_root = resource.contents[0]
        rset.metamodel_registry[mm_root.nsURI] = mm_root
        
        resource = JsonResource(URI('project.json'))
        resource.append(p)
        resource.save()

        ref_p = RefProject(name="RefMyProject", version=v1)
        resource = JsonResource(URI('ref_project.json'))
        resource.append(ref_p)
        resource.save()

        rset = ResourceSet()
        rset.resource_factory['json'] = JsonResource
        resource = rset.get_resource(URI('miniModel.ecore'))
        mm_root = resource.contents[0]
        rset.metamodel_registry[mm_root.nsURI] = mm_root

        rset.get_resource(URI('project.json'))
        resource = rset.get_resource(URI('ref_project.json'))
        ref_project = resource.contents[0]
        
        assert ref_project.version.name == "V1"        
